<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    package com.jmatio.types;<a name="line.1"></a>
<FONT color="green">002</FONT>    <a name="line.2"></a>
<FONT color="green">003</FONT>    public class MLArray<a name="line.3"></a>
<FONT color="green">004</FONT>    {<a name="line.4"></a>
<FONT color="green">005</FONT>        <a name="line.5"></a>
<FONT color="green">006</FONT>        /* Matlab Array Types (Classes) */<a name="line.6"></a>
<FONT color="green">007</FONT>        public static final int mxUNKNOWN_CLASS = 0;<a name="line.7"></a>
<FONT color="green">008</FONT>        public static final int mxCELL_CLASS    = 1;<a name="line.8"></a>
<FONT color="green">009</FONT>        public static final int mxSTRUCT_CLASS  = 2;<a name="line.9"></a>
<FONT color="green">010</FONT>        public static final int mxOBJECT_CLASS  = 3;<a name="line.10"></a>
<FONT color="green">011</FONT>        public static final int mxCHAR_CLASS    = 4;<a name="line.11"></a>
<FONT color="green">012</FONT>        public static final int mxSPARSE_CLASS  = 5;<a name="line.12"></a>
<FONT color="green">013</FONT>        public static final int mxDOUBLE_CLASS  = 6;<a name="line.13"></a>
<FONT color="green">014</FONT>        public static final int mxSINGLE_CLASS  = 7;<a name="line.14"></a>
<FONT color="green">015</FONT>        public static final int mxINT8_CLASS    = 8;<a name="line.15"></a>
<FONT color="green">016</FONT>        public static final int mxUINT8_CLASS   = 9;<a name="line.16"></a>
<FONT color="green">017</FONT>        public static final int mxINT16_CLASS   = 10;<a name="line.17"></a>
<FONT color="green">018</FONT>        public static final int mxUINT16_CLASS  = 11;<a name="line.18"></a>
<FONT color="green">019</FONT>        public static final int mxINT32_CLASS   = 12;<a name="line.19"></a>
<FONT color="green">020</FONT>        public static final int mxUINT32_CLASS  = 13;<a name="line.20"></a>
<FONT color="green">021</FONT>        public static final int mxINT64_CLASS   = 14;<a name="line.21"></a>
<FONT color="green">022</FONT>        public static final int mxUINT64_CLASS  = 15;<a name="line.22"></a>
<FONT color="green">023</FONT>        public static final int mxFUNCTION_CLASS = 16;<a name="line.23"></a>
<FONT color="green">024</FONT>        public static final int mxOPAQUE_CLASS  = 17;<a name="line.24"></a>
<FONT color="green">025</FONT>        <a name="line.25"></a>
<FONT color="green">026</FONT>        public static final int mtFLAG_COMPLEX       = 0x0800;<a name="line.26"></a>
<FONT color="green">027</FONT>        public static final int mtFLAG_GLOBAL        = 0x0400;<a name="line.27"></a>
<FONT color="green">028</FONT>        public static final int mtFLAG_LOGICAL       = 0x0200;<a name="line.28"></a>
<FONT color="green">029</FONT>        public static final int mtFLAG_TYPE          = 0xff;<a name="line.29"></a>
<FONT color="green">030</FONT>        <a name="line.30"></a>
<FONT color="green">031</FONT>        protected int dims[];<a name="line.31"></a>
<FONT color="green">032</FONT>        public String name;<a name="line.32"></a>
<FONT color="green">033</FONT>        protected int attributes;<a name="line.33"></a>
<FONT color="green">034</FONT>        protected int type;<a name="line.34"></a>
<FONT color="green">035</FONT>        <a name="line.35"></a>
<FONT color="green">036</FONT>        public MLArray(String name, int[] dims, int type, int attributes)<a name="line.36"></a>
<FONT color="green">037</FONT>        {<a name="line.37"></a>
<FONT color="green">038</FONT>            this.dims = new int[dims.length];<a name="line.38"></a>
<FONT color="green">039</FONT>            System.arraycopy(dims, 0, this.dims, 0, dims.length);<a name="line.39"></a>
<FONT color="green">040</FONT>            <a name="line.40"></a>
<FONT color="green">041</FONT>            <a name="line.41"></a>
<FONT color="green">042</FONT>            if ( name != null &amp;&amp; !name.equals("") )<a name="line.42"></a>
<FONT color="green">043</FONT>            {<a name="line.43"></a>
<FONT color="green">044</FONT>                this.name = name;<a name="line.44"></a>
<FONT color="green">045</FONT>            }<a name="line.45"></a>
<FONT color="green">046</FONT>            else<a name="line.46"></a>
<FONT color="green">047</FONT>            {<a name="line.47"></a>
<FONT color="green">048</FONT>                this.name = "@"; //default name<a name="line.48"></a>
<FONT color="green">049</FONT>            }<a name="line.49"></a>
<FONT color="green">050</FONT>            <a name="line.50"></a>
<FONT color="green">051</FONT>            <a name="line.51"></a>
<FONT color="green">052</FONT>            this.type = type;<a name="line.52"></a>
<FONT color="green">053</FONT>            this.attributes = attributes;<a name="line.53"></a>
<FONT color="green">054</FONT>        }<a name="line.54"></a>
<FONT color="green">055</FONT>        <a name="line.55"></a>
<FONT color="green">056</FONT>        /**<a name="line.56"></a>
<FONT color="green">057</FONT>         * Gets array name<a name="line.57"></a>
<FONT color="green">058</FONT>         * <a name="line.58"></a>
<FONT color="green">059</FONT>         * @return - array name<a name="line.59"></a>
<FONT color="green">060</FONT>         */<a name="line.60"></a>
<FONT color="green">061</FONT>        public String getName()<a name="line.61"></a>
<FONT color="green">062</FONT>        {<a name="line.62"></a>
<FONT color="green">063</FONT>            return name;<a name="line.63"></a>
<FONT color="green">064</FONT>        }<a name="line.64"></a>
<FONT color="green">065</FONT>        public int getFlags()<a name="line.65"></a>
<FONT color="green">066</FONT>        { <a name="line.66"></a>
<FONT color="green">067</FONT>            int flags = type &amp; mtFLAG_TYPE | attributes &amp; 0xffffff00;<a name="line.67"></a>
<FONT color="green">068</FONT>            <a name="line.68"></a>
<FONT color="green">069</FONT>            return flags;<a name="line.69"></a>
<FONT color="green">070</FONT>        }<a name="line.70"></a>
<FONT color="green">071</FONT>        public byte[] getNameToByteArray()<a name="line.71"></a>
<FONT color="green">072</FONT>        {<a name="line.72"></a>
<FONT color="green">073</FONT>            return name.getBytes();<a name="line.73"></a>
<FONT color="green">074</FONT>        }<a name="line.74"></a>
<FONT color="green">075</FONT>        <a name="line.75"></a>
<FONT color="green">076</FONT>        public int[] getDimensions()<a name="line.76"></a>
<FONT color="green">077</FONT>        {<a name="line.77"></a>
<FONT color="green">078</FONT>            int ai[] = null;<a name="line.78"></a>
<FONT color="green">079</FONT>            if(dims != null)<a name="line.79"></a>
<FONT color="green">080</FONT>            {<a name="line.80"></a>
<FONT color="green">081</FONT>                ai = new int[dims.length];<a name="line.81"></a>
<FONT color="green">082</FONT>                System.arraycopy(dims, 0, ai, 0, dims.length);<a name="line.82"></a>
<FONT color="green">083</FONT>            }<a name="line.83"></a>
<FONT color="green">084</FONT>            return ai;<a name="line.84"></a>
<FONT color="green">085</FONT>        }<a name="line.85"></a>
<FONT color="green">086</FONT>    <a name="line.86"></a>
<FONT color="green">087</FONT>        public int getM()<a name="line.87"></a>
<FONT color="green">088</FONT>        {<a name="line.88"></a>
<FONT color="green">089</FONT>            int i = 0;<a name="line.89"></a>
<FONT color="green">090</FONT>            if( dims != null )<a name="line.90"></a>
<FONT color="green">091</FONT>            {<a name="line.91"></a>
<FONT color="green">092</FONT>                i = dims[0];<a name="line.92"></a>
<FONT color="green">093</FONT>            }<a name="line.93"></a>
<FONT color="green">094</FONT>            return i;<a name="line.94"></a>
<FONT color="green">095</FONT>        }<a name="line.95"></a>
<FONT color="green">096</FONT>    <a name="line.96"></a>
<FONT color="green">097</FONT>        public int getN()<a name="line.97"></a>
<FONT color="green">098</FONT>        {<a name="line.98"></a>
<FONT color="green">099</FONT>            int i = 0;<a name="line.99"></a>
<FONT color="green">100</FONT>            if(dims != null)<a name="line.100"></a>
<FONT color="green">101</FONT>            {<a name="line.101"></a>
<FONT color="green">102</FONT>                if(dims.length &gt; 2)<a name="line.102"></a>
<FONT color="green">103</FONT>                {<a name="line.103"></a>
<FONT color="green">104</FONT>                    i = 1;<a name="line.104"></a>
<FONT color="green">105</FONT>                    for(int j = 1; j &lt; dims.length; j++)<a name="line.105"></a>
<FONT color="green">106</FONT>                    {<a name="line.106"></a>
<FONT color="green">107</FONT>                        i *= dims[j];<a name="line.107"></a>
<FONT color="green">108</FONT>                    }<a name="line.108"></a>
<FONT color="green">109</FONT>                } <a name="line.109"></a>
<FONT color="green">110</FONT>                else<a name="line.110"></a>
<FONT color="green">111</FONT>                {<a name="line.111"></a>
<FONT color="green">112</FONT>                    i = dims[1];<a name="line.112"></a>
<FONT color="green">113</FONT>                }<a name="line.113"></a>
<FONT color="green">114</FONT>            }<a name="line.114"></a>
<FONT color="green">115</FONT>            return i;<a name="line.115"></a>
<FONT color="green">116</FONT>        }<a name="line.116"></a>
<FONT color="green">117</FONT>    <a name="line.117"></a>
<FONT color="green">118</FONT>        public int getNDimensions()<a name="line.118"></a>
<FONT color="green">119</FONT>        {<a name="line.119"></a>
<FONT color="green">120</FONT>            int i = 0;<a name="line.120"></a>
<FONT color="green">121</FONT>            if(dims != null)<a name="line.121"></a>
<FONT color="green">122</FONT>            {<a name="line.122"></a>
<FONT color="green">123</FONT>                i = dims.length;<a name="line.123"></a>
<FONT color="green">124</FONT>            }<a name="line.124"></a>
<FONT color="green">125</FONT>            return i;<a name="line.125"></a>
<FONT color="green">126</FONT>        }<a name="line.126"></a>
<FONT color="green">127</FONT>        public int getSize()<a name="line.127"></a>
<FONT color="green">128</FONT>        {<a name="line.128"></a>
<FONT color="green">129</FONT>            return getM()*getN();<a name="line.129"></a>
<FONT color="green">130</FONT>        }<a name="line.130"></a>
<FONT color="green">131</FONT>        public int getType()<a name="line.131"></a>
<FONT color="green">132</FONT>        {<a name="line.132"></a>
<FONT color="green">133</FONT>            return type;<a name="line.133"></a>
<FONT color="green">134</FONT>        }<a name="line.134"></a>
<FONT color="green">135</FONT>    <a name="line.135"></a>
<FONT color="green">136</FONT>        public boolean isEmpty()<a name="line.136"></a>
<FONT color="green">137</FONT>        {<a name="line.137"></a>
<FONT color="green">138</FONT>            return getN() == 0;<a name="line.138"></a>
<FONT color="green">139</FONT>        }<a name="line.139"></a>
<FONT color="green">140</FONT>        <a name="line.140"></a>
<FONT color="green">141</FONT>        public static final String typeToString(int type)<a name="line.141"></a>
<FONT color="green">142</FONT>        {<a name="line.142"></a>
<FONT color="green">143</FONT>            String s;<a name="line.143"></a>
<FONT color="green">144</FONT>            switch (type)<a name="line.144"></a>
<FONT color="green">145</FONT>            {<a name="line.145"></a>
<FONT color="green">146</FONT>                case mxUNKNOWN_CLASS:<a name="line.146"></a>
<FONT color="green">147</FONT>                    s = "unknown";<a name="line.147"></a>
<FONT color="green">148</FONT>                    break;<a name="line.148"></a>
<FONT color="green">149</FONT>                case mxCELL_CLASS:<a name="line.149"></a>
<FONT color="green">150</FONT>                    s = "cell";<a name="line.150"></a>
<FONT color="green">151</FONT>                    break;<a name="line.151"></a>
<FONT color="green">152</FONT>                case mxSTRUCT_CLASS:<a name="line.152"></a>
<FONT color="green">153</FONT>                    s = "struct";<a name="line.153"></a>
<FONT color="green">154</FONT>                    break;<a name="line.154"></a>
<FONT color="green">155</FONT>                case mxCHAR_CLASS:<a name="line.155"></a>
<FONT color="green">156</FONT>                    s = "char";<a name="line.156"></a>
<FONT color="green">157</FONT>                    break;<a name="line.157"></a>
<FONT color="green">158</FONT>                case mxSPARSE_CLASS:<a name="line.158"></a>
<FONT color="green">159</FONT>                    s = "sparse";<a name="line.159"></a>
<FONT color="green">160</FONT>                    break;<a name="line.160"></a>
<FONT color="green">161</FONT>                case mxDOUBLE_CLASS:<a name="line.161"></a>
<FONT color="green">162</FONT>                    s = "double";<a name="line.162"></a>
<FONT color="green">163</FONT>                    break;<a name="line.163"></a>
<FONT color="green">164</FONT>                case mxSINGLE_CLASS:<a name="line.164"></a>
<FONT color="green">165</FONT>                    s = "single";<a name="line.165"></a>
<FONT color="green">166</FONT>                    break;<a name="line.166"></a>
<FONT color="green">167</FONT>                case mxINT8_CLASS:<a name="line.167"></a>
<FONT color="green">168</FONT>                    s = "int8";<a name="line.168"></a>
<FONT color="green">169</FONT>                    break;<a name="line.169"></a>
<FONT color="green">170</FONT>                case mxUINT8_CLASS:<a name="line.170"></a>
<FONT color="green">171</FONT>                    s = "uint8";<a name="line.171"></a>
<FONT color="green">172</FONT>                    break;<a name="line.172"></a>
<FONT color="green">173</FONT>                case mxINT16_CLASS:<a name="line.173"></a>
<FONT color="green">174</FONT>                    s = "int16";<a name="line.174"></a>
<FONT color="green">175</FONT>                    break;<a name="line.175"></a>
<FONT color="green">176</FONT>                case mxUINT16_CLASS:<a name="line.176"></a>
<FONT color="green">177</FONT>                    s = "uint16";<a name="line.177"></a>
<FONT color="green">178</FONT>                    break;<a name="line.178"></a>
<FONT color="green">179</FONT>                case mxINT32_CLASS:<a name="line.179"></a>
<FONT color="green">180</FONT>                    s = "int32";<a name="line.180"></a>
<FONT color="green">181</FONT>                    break;<a name="line.181"></a>
<FONT color="green">182</FONT>                case mxUINT32_CLASS:<a name="line.182"></a>
<FONT color="green">183</FONT>                    s = "uint32";<a name="line.183"></a>
<FONT color="green">184</FONT>                    break;<a name="line.184"></a>
<FONT color="green">185</FONT>                case mxINT64_CLASS:<a name="line.185"></a>
<FONT color="green">186</FONT>                    s = "int64";<a name="line.186"></a>
<FONT color="green">187</FONT>                    break;<a name="line.187"></a>
<FONT color="green">188</FONT>                case mxUINT64_CLASS:<a name="line.188"></a>
<FONT color="green">189</FONT>                    s = "uint64";<a name="line.189"></a>
<FONT color="green">190</FONT>                    break;<a name="line.190"></a>
<FONT color="green">191</FONT>                case mxFUNCTION_CLASS:<a name="line.191"></a>
<FONT color="green">192</FONT>                    s = "function_handle";<a name="line.192"></a>
<FONT color="green">193</FONT>                    break;<a name="line.193"></a>
<FONT color="green">194</FONT>                case mxOPAQUE_CLASS:<a name="line.194"></a>
<FONT color="green">195</FONT>                    s = "opaque";<a name="line.195"></a>
<FONT color="green">196</FONT>                    break;<a name="line.196"></a>
<FONT color="green">197</FONT>                case mxOBJECT_CLASS:<a name="line.197"></a>
<FONT color="green">198</FONT>                    s = "object";<a name="line.198"></a>
<FONT color="green">199</FONT>                    break;<a name="line.199"></a>
<FONT color="green">200</FONT>                default:<a name="line.200"></a>
<FONT color="green">201</FONT>                    s = "unknown";<a name="line.201"></a>
<FONT color="green">202</FONT>                    break;<a name="line.202"></a>
<FONT color="green">203</FONT>            }<a name="line.203"></a>
<FONT color="green">204</FONT>            return s;<a name="line.204"></a>
<FONT color="green">205</FONT>        }<a name="line.205"></a>
<FONT color="green">206</FONT>        <a name="line.206"></a>
<FONT color="green">207</FONT>        public boolean isCell()<a name="line.207"></a>
<FONT color="green">208</FONT>        {<a name="line.208"></a>
<FONT color="green">209</FONT>            return type == mxCELL_CLASS;<a name="line.209"></a>
<FONT color="green">210</FONT>        }<a name="line.210"></a>
<FONT color="green">211</FONT>    <a name="line.211"></a>
<FONT color="green">212</FONT>        public boolean isChar()<a name="line.212"></a>
<FONT color="green">213</FONT>        {<a name="line.213"></a>
<FONT color="green">214</FONT>            return type == mxCHAR_CLASS;<a name="line.214"></a>
<FONT color="green">215</FONT>        }<a name="line.215"></a>
<FONT color="green">216</FONT>    <a name="line.216"></a>
<FONT color="green">217</FONT>        public boolean isComplex()<a name="line.217"></a>
<FONT color="green">218</FONT>        {<a name="line.218"></a>
<FONT color="green">219</FONT>            return (attributes &amp; mtFLAG_COMPLEX) != 0;<a name="line.219"></a>
<FONT color="green">220</FONT>        }<a name="line.220"></a>
<FONT color="green">221</FONT>    <a name="line.221"></a>
<FONT color="green">222</FONT>        public boolean isSparse()<a name="line.222"></a>
<FONT color="green">223</FONT>        {<a name="line.223"></a>
<FONT color="green">224</FONT>            return type == mxSPARSE_CLASS;<a name="line.224"></a>
<FONT color="green">225</FONT>        }<a name="line.225"></a>
<FONT color="green">226</FONT>    <a name="line.226"></a>
<FONT color="green">227</FONT>        public boolean isStruct()<a name="line.227"></a>
<FONT color="green">228</FONT>        {<a name="line.228"></a>
<FONT color="green">229</FONT>            return type == mxSTRUCT_CLASS;<a name="line.229"></a>
<FONT color="green">230</FONT>        }<a name="line.230"></a>
<FONT color="green">231</FONT>    <a name="line.231"></a>
<FONT color="green">232</FONT>        public boolean isDouble()<a name="line.232"></a>
<FONT color="green">233</FONT>        {<a name="line.233"></a>
<FONT color="green">234</FONT>            return type == mxDOUBLE_CLASS;<a name="line.234"></a>
<FONT color="green">235</FONT>        }<a name="line.235"></a>
<FONT color="green">236</FONT>    <a name="line.236"></a>
<FONT color="green">237</FONT>        public boolean isSingle()<a name="line.237"></a>
<FONT color="green">238</FONT>        {<a name="line.238"></a>
<FONT color="green">239</FONT>            return type == mxSINGLE_CLASS;<a name="line.239"></a>
<FONT color="green">240</FONT>        }<a name="line.240"></a>
<FONT color="green">241</FONT>    <a name="line.241"></a>
<FONT color="green">242</FONT>        public boolean isInt8()<a name="line.242"></a>
<FONT color="green">243</FONT>        {<a name="line.243"></a>
<FONT color="green">244</FONT>            return type == mxINT8_CLASS;<a name="line.244"></a>
<FONT color="green">245</FONT>        }<a name="line.245"></a>
<FONT color="green">246</FONT>    <a name="line.246"></a>
<FONT color="green">247</FONT>        public boolean isUint8()<a name="line.247"></a>
<FONT color="green">248</FONT>        {<a name="line.248"></a>
<FONT color="green">249</FONT>            return type == mxUINT8_CLASS;<a name="line.249"></a>
<FONT color="green">250</FONT>        }<a name="line.250"></a>
<FONT color="green">251</FONT>    <a name="line.251"></a>
<FONT color="green">252</FONT>        public boolean isInt16()<a name="line.252"></a>
<FONT color="green">253</FONT>        {<a name="line.253"></a>
<FONT color="green">254</FONT>            return type == mxINT16_CLASS;<a name="line.254"></a>
<FONT color="green">255</FONT>        }<a name="line.255"></a>
<FONT color="green">256</FONT>    <a name="line.256"></a>
<FONT color="green">257</FONT>        public boolean isUint16()<a name="line.257"></a>
<FONT color="green">258</FONT>        {<a name="line.258"></a>
<FONT color="green">259</FONT>            return type == mxUINT16_CLASS;<a name="line.259"></a>
<FONT color="green">260</FONT>        }<a name="line.260"></a>
<FONT color="green">261</FONT>    <a name="line.261"></a>
<FONT color="green">262</FONT>        public boolean isInt32()<a name="line.262"></a>
<FONT color="green">263</FONT>        {<a name="line.263"></a>
<FONT color="green">264</FONT>            return type == mxINT32_CLASS;<a name="line.264"></a>
<FONT color="green">265</FONT>        }<a name="line.265"></a>
<FONT color="green">266</FONT>    <a name="line.266"></a>
<FONT color="green">267</FONT>        public boolean isUint32()<a name="line.267"></a>
<FONT color="green">268</FONT>        {<a name="line.268"></a>
<FONT color="green">269</FONT>            return type == mxUINT32_CLASS;<a name="line.269"></a>
<FONT color="green">270</FONT>        }<a name="line.270"></a>
<FONT color="green">271</FONT>    <a name="line.271"></a>
<FONT color="green">272</FONT>        public boolean isInt64()<a name="line.272"></a>
<FONT color="green">273</FONT>        {<a name="line.273"></a>
<FONT color="green">274</FONT>            return type == mxINT64_CLASS;<a name="line.274"></a>
<FONT color="green">275</FONT>        }<a name="line.275"></a>
<FONT color="green">276</FONT>    <a name="line.276"></a>
<FONT color="green">277</FONT>        public boolean isUint64()<a name="line.277"></a>
<FONT color="green">278</FONT>        {<a name="line.278"></a>
<FONT color="green">279</FONT>            return type == mxUINT64_CLASS;<a name="line.279"></a>
<FONT color="green">280</FONT>        }<a name="line.280"></a>
<FONT color="green">281</FONT>    <a name="line.281"></a>
<FONT color="green">282</FONT>        public boolean isObject()<a name="line.282"></a>
<FONT color="green">283</FONT>        {<a name="line.283"></a>
<FONT color="green">284</FONT>            return type == mxOBJECT_CLASS;<a name="line.284"></a>
<FONT color="green">285</FONT>        }<a name="line.285"></a>
<FONT color="green">286</FONT>    <a name="line.286"></a>
<FONT color="green">287</FONT>        public boolean isOpaque()<a name="line.287"></a>
<FONT color="green">288</FONT>        {<a name="line.288"></a>
<FONT color="green">289</FONT>            return type == mxOPAQUE_CLASS;<a name="line.289"></a>
<FONT color="green">290</FONT>        }<a name="line.290"></a>
<FONT color="green">291</FONT>    <a name="line.291"></a>
<FONT color="green">292</FONT>        public boolean isLogical()<a name="line.292"></a>
<FONT color="green">293</FONT>        {<a name="line.293"></a>
<FONT color="green">294</FONT>            return (attributes &amp; mtFLAG_LOGICAL) != 0;<a name="line.294"></a>
<FONT color="green">295</FONT>        }<a name="line.295"></a>
<FONT color="green">296</FONT>    <a name="line.296"></a>
<FONT color="green">297</FONT>        public boolean isFunctionObject()<a name="line.297"></a>
<FONT color="green">298</FONT>        {<a name="line.298"></a>
<FONT color="green">299</FONT>            return type == mxFUNCTION_CLASS;<a name="line.299"></a>
<FONT color="green">300</FONT>        }<a name="line.300"></a>
<FONT color="green">301</FONT>    <a name="line.301"></a>
<FONT color="green">302</FONT>        public boolean isUnknown()<a name="line.302"></a>
<FONT color="green">303</FONT>        {<a name="line.303"></a>
<FONT color="green">304</FONT>            return type == mxUNKNOWN_CLASS;<a name="line.304"></a>
<FONT color="green">305</FONT>        }<a name="line.305"></a>
<FONT color="green">306</FONT>        protected int getIndex(int m, int n)<a name="line.306"></a>
<FONT color="green">307</FONT>        {<a name="line.307"></a>
<FONT color="green">308</FONT>            return m+n*getM();<a name="line.308"></a>
<FONT color="green">309</FONT>        }<a name="line.309"></a>
<FONT color="green">310</FONT>        <a name="line.310"></a>
<FONT color="green">311</FONT>        @Override<a name="line.311"></a>
<FONT color="green">312</FONT>            public String toString()<a name="line.312"></a>
<FONT color="green">313</FONT>        {<a name="line.313"></a>
<FONT color="green">314</FONT>            StringBuffer sb = new StringBuffer();<a name="line.314"></a>
<FONT color="green">315</FONT>            if (dims != null)<a name="line.315"></a>
<FONT color="green">316</FONT>            {<a name="line.316"></a>
<FONT color="green">317</FONT>                sb.append('[');<a name="line.317"></a>
<FONT color="green">318</FONT>                if (dims.length &gt; 3)<a name="line.318"></a>
<FONT color="green">319</FONT>                {<a name="line.319"></a>
<FONT color="green">320</FONT>                    sb.append(dims.length);<a name="line.320"></a>
<FONT color="green">321</FONT>                    sb.append('D');<a name="line.321"></a>
<FONT color="green">322</FONT>                }<a name="line.322"></a>
<FONT color="green">323</FONT>                else<a name="line.323"></a>
<FONT color="green">324</FONT>                {<a name="line.324"></a>
<FONT color="green">325</FONT>                    sb.append(dims[0]);<a name="line.325"></a>
<FONT color="green">326</FONT>                    sb.append('x');<a name="line.326"></a>
<FONT color="green">327</FONT>                    sb.append(dims[1]);<a name="line.327"></a>
<FONT color="green">328</FONT>                    if (dims.length == 3)<a name="line.328"></a>
<FONT color="green">329</FONT>                    {<a name="line.329"></a>
<FONT color="green">330</FONT>                        sb.append('x');<a name="line.330"></a>
<FONT color="green">331</FONT>                        sb.append(dims[2]);<a name="line.331"></a>
<FONT color="green">332</FONT>                    }<a name="line.332"></a>
<FONT color="green">333</FONT>                }<a name="line.333"></a>
<FONT color="green">334</FONT>                sb.append("  ");<a name="line.334"></a>
<FONT color="green">335</FONT>                sb.append(typeToString(type));<a name="line.335"></a>
<FONT color="green">336</FONT>                sb.append(" array");<a name="line.336"></a>
<FONT color="green">337</FONT>                if (isSparse())<a name="line.337"></a>
<FONT color="green">338</FONT>                {<a name="line.338"></a>
<FONT color="green">339</FONT>                    sb.append(" (sparse");<a name="line.339"></a>
<FONT color="green">340</FONT>                    if (isComplex())<a name="line.340"></a>
<FONT color="green">341</FONT>                    {<a name="line.341"></a>
<FONT color="green">342</FONT>                        sb.append(" complex");<a name="line.342"></a>
<FONT color="green">343</FONT>                    }<a name="line.343"></a>
<FONT color="green">344</FONT>                    sb.append(")");<a name="line.344"></a>
<FONT color="green">345</FONT>                }<a name="line.345"></a>
<FONT color="green">346</FONT>                else if (isComplex())<a name="line.346"></a>
<FONT color="green">347</FONT>                {<a name="line.347"></a>
<FONT color="green">348</FONT>                    sb.append(" (complex)");<a name="line.348"></a>
<FONT color="green">349</FONT>                }<a name="line.349"></a>
<FONT color="green">350</FONT>                sb.append(']');<a name="line.350"></a>
<FONT color="green">351</FONT>            }<a name="line.351"></a>
<FONT color="green">352</FONT>            else<a name="line.352"></a>
<FONT color="green">353</FONT>            {<a name="line.353"></a>
<FONT color="green">354</FONT>                sb.append("[invalid]");<a name="line.354"></a>
<FONT color="green">355</FONT>            }<a name="line.355"></a>
<FONT color="green">356</FONT>            return sb.toString();<a name="line.356"></a>
<FONT color="green">357</FONT>        }<a name="line.357"></a>
<FONT color="green">358</FONT>        <a name="line.358"></a>
<FONT color="green">359</FONT>        public String contentToString()<a name="line.359"></a>
<FONT color="green">360</FONT>        {<a name="line.360"></a>
<FONT color="green">361</FONT>            return "content cannot be displayed";<a name="line.361"></a>
<FONT color="green">362</FONT>        }<a name="line.362"></a>
<FONT color="green">363</FONT>    }<a name="line.363"></a>




























































</PRE>
</BODY>
</HTML>
